
package de.ivu.elect.presentation.entschaedigung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.entschaedigung.boundary.AuszahlungBoundaryCreate;
import de.ivu.elect.business.entschaedigung.boundary.AuszahlungFactory;
import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.entschaedigung.entity.AuszahlungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractAuszahlungCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractAuszahlungCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.AUSZAHLUNG_CREATE)
public abstract class AbstractAuszahlungCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Auszahlung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "auszahlungCreateView";

  public static final String VIEW_ID = "/entschaedigung/auszahlung-create.xhtml";

  public static final String PARENT_VIEW_ID = "/entschaedigung/auszahlung-search.xhtml";

  @Inject
  protected transient AuszahlungBoundaryCreate create;

  protected Auszahlung entity;

  @Inject
  protected transient AuszahlungMeta entityMeta;

  
  @Inject
  protected transient AuszahlungFactory factory;

  public AbstractAuszahlungCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public Auszahlung getEntity() {
    return entity;
  }

  protected void setEntity(Auszahlung entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUSZAHLUNG_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Auszahlung entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Auszahlung entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.AUSZAHLUNG_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
